//ts-check

import eslint from "@eslint/js";
import tseslint from "typescript-eslint";

export default [
    {
        ignores: [
            "./dist/**/*",
            "./src/**/generated/**/*",
            "./generated/**/*",
            "esbuild.mjs",
            "jest.config.js",
            "postcss.config.js",
            "tailwind.config.js",
        ]
    },
    ...tseslint.config(
        eslint.configs.recommended,
        tseslint.configs.recommended,
        {
            files: ["./src/**/*.{ts,js}"],
            rules: {
                "@typescript-eslint/no-unused-vars": [
                    "error", {
                        "argsIgnorePattern": "^_",
                        "varsIgnorePattern": "^_"
                    }
                ],
                "@typescript-eslint/no-explicit-any": "off"
            }
        }
    )
];