import { RESTPostAPIApplicationCommandsJSONBody, SlashCommandBuilder, ToAPIApplicationCommandOptions } from "discord.js";
import DiscordBot from "@bot/bot";

export default class Interaction {
    readonly client: DiscordBot;
    name!: string;
    description: string = "No description";
    options: ToAPIApplicationCommandOptions[] = [];
    dmPermission!: boolean;

    constructor(client: DiscordBot) {
        this.client = client;
    }

    execute(..._args: unknown[]) {
        throw new Error("No execute override");
    }

    toJSON(): RESTPostAPIApplicationCommandsJSONBody {
        const command = new SlashCommandBuilder();

        command.setName(this.name);
        command.setDescription(this.description);
        command.setDMPermission(this.dmPermission);  // TODO: deprecated - replace

        for (const option of this.options) {
            command.options.push(option);
        }

        return command.toJSON();
    }
}
